#ifndef __IMCONFIG_H__
#define __IMCONFIG_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>

//For sleep
#include <unistd.h>

#define GL_CODE_RX_COMMAND        0x1234AB01
#define GL_CODE_TX_COMMAND        0x1234AB02
#define GL_CODE_TX_DATA           0x1234AB03
#define GL_CODE_RX_DATA           0x1234AB04

struct receivedPacket {
	int bytesRecv;		//Length of full packet
	char data[2000];
	unsigned int counter;
	unsigned int type;
	int len;		//Length of message
};

class IMConfig {
private:
	struct sockaddr_in ser, serviceIn;
	int ListenSocketIn;
	int count;

public:
	struct receivedPacket received;

	IMConfig();
	int setSerIP(char* IP);				//Set IP for destination packets
	int bindSocket();
	int sendUDP(char* udp);
	unsigned int receiveUDP();
	void processPacketUDP (char* data, int len);
	int sendRegister();
	int sendInfo();
	int sendReset();
	int sendSetIP(char* IP);
	int sendFile(char* fileName);
	int sendLicense(char* License);
    int sendDirect(char* str);

private:
	unsigned int calcconsum(unsigned char *data, int len);
};

#endif
